import RPi.GPIO as GPIO
import time 
import subprocess
import os
import Adafruit_SSD1306
from PIL import Image
from PIL import ImageDraw
from PIL import ImageFont

cmd = "aconnect -io"
result = os.popen(cmd).read()
print(result)

result = result.split("\n")

usbcard=0
ttymidi=0

for num in range(0,len(result)):
    if result[num].count("client") == 1:    
        if result[num].count("card=") == 1:
            a=result[num].split(":")
            a[0]=a[0].replace('client ', '')
            usbcard = int(a[0])
            #print(usbcard)
        if result[num].count("ttymidi") == 1:
            a=result[num].split(":")
            a[0]=a[0].replace('client ', '')
            ttymidi = int(a[0])
            #print(ttymidi)
                           

oledprint1="USB=[ "+str(usbcard) +" ]"
oledprint2="ttymidi=[ "+str(ttymidi)+" ]"

print(oledprint1)
print(oledprint2)

cmd = "sudo aconnect "+ str(ttymidi)+":0"+" "+str(usbcard)+":0"
print(cmd)
proc = subprocess.Popen(cmd.split(), stdout=subprocess.PIPE)


def initialize_display():
    # Raspberry Pi pin configuration is "NONE" as it isn't used
    RST = None

    # 128x64 display with hardware I2C
    disp = Adafruit_SSD1306.SSD1306_128_64(rst=RST)

    # Initialize and clear display
    disp.begin()
    disp.clear()
    disp.display()

    return(disp)

def initialize_image(disp):
    # Create a blank image object for drawing by using Pillow with 1-bit color.
    width = disp.width
    height = disp.height
    image = Image.new('1', (width, height))

    draw = ImageDraw.Draw(image)

    return(image, draw)

def write_image(disp, draw, image):

    draw.text((0, 0),"ハードウェアMIDI", font=font, fill=255)
    draw.text((0,20), oledprint1, font=font, fill=255)
    draw.text((0,40), oledprint2,  font=font, fill=255)

    disp.image(image)
    disp.display()

font = ImageFont.truetype('SourceHanSansJP-Medium.otf', 15)
disp = initialize_display()
image, draw = initialize_image(disp)
write_image(disp, draw, image)
